#include "scripts/debug.lua"
#include "scripts/fps.lua"
#include "scripts/slime.lua"
#include "scripts/gun.lua"
#include "scripts/projectiles.lua"
#include "scripts/registry.lua"
#include "scripts/timers.lua"
#include "scripts/sound.lua"
#include "scripts/tool.lua"
#include "scripts/umf.lua"
#include "scripts/ui.lua"
#include "scripts/utility.lua"

------------------------------------------------
--- Hungry Slimes
--- By: Geneosis
------------------------------------------------

CONFIG = {
    soundEnabled = true,
    slowMotion = false,
}

hintTimer = 6

function init()

    UI_GAME = false
    checkRegInitialized()

    initDebug()
    initSounds()

    tool.tool.init()
    initTimers()

end

function tick()

    -- Fix broken sound after quicksave reload
    if not sounds or not sounds.play or not sounds.play.pour then
        initSounds()
        initTimers()
    end

    runTimers()
    manageProjectiles()

    tool.run()
    Slime.run()

    debugMod()

end


function draw()

    FPS.update()

    if not regGetBool('perfo.renderSlimeParticles') then
        Slime.slimes.effects.renderSlimesIdleSimple()
    end

    if tool.tool.active() then
        -- Update key hint
        hintTimer = hintTimer - GetTimeStep()
		uiDrawKeyHint()
    else
		hintTimer = 6
	end

    uiManageGameOptions()

end

UpdateQuickloadPatch()
