function modReset()

    -- Tool
    regSetFloat('tool.pour.gravity'   , 0.03)
    regSetFloat('tool.pour.rate'      , 1600)
    regSetFloat('tool.pour.spread'    , 10)
    regSetFloat('tool.pour.velocity'  , 0.25)
    regSetBool('tool.debugMode'       , false)

    -- Slime
    regSetFloat('slime.eatRadius'       , 0.1)
    regSetInt('slime.duplicationRate'   , 1)
    regSetFloat('slime.eatDelay'        , 0.2)
    regSetFloat('slime.jumpDistance'    , 1)
    regSetFloat('slime.color.r'         , 130)
    regSetFloat('slime.color.g'         , 122)
    regSetFloat('slime.color.b'         , 248)
    regSetFloat('slime.color.a'         , 127)
    regSetFloat('slime.glow'            , 1)
    regSetBool('slime.soundOn'          , true)
    regSetBool('slime.scaleWithRadius'  , false)
    regSetFloat('slime.size'            , 0.2)
    regSetFloat('slime.lifeDuration'    , 0)
    regSetBool('slime.hiveMind'         , false)
    regSetBool('slime.eatPlayer'        , false)

    -- Performance
    regSetBool('perfo.particleTypeSmoke'     , true)
    regSetBool('perfo.renderSlimeParticles'  , true)
    regSetFloat('perfo.killToMaintainFPS'    , 0)
    regSetInt('perfo.slimesMaxPopulation'    , 500)
    regSetInt('perfo.slimesMaxDuplication'   , 100)
    regSetBool('perfo.killSlimeAfterLastDup' , false)
    regSetInt('perfo.slimesMaxGeneration'    , 0)
    regSetBool('perfo.killStackedSlimes'     , true)
    regSetBool('perfo.preventDup'            , false)
    regSetBool('perfo.eatOneAtATime'         , false)
    regSetBool('perfo.gooMode'               , false)
    regSetBool('perfo.eatOnlyFirst'          , false)
    regSetBool('perfo.freezeWhenEating'      , false)
    regSetBool('perfo.noEatingWhileMoving'   , false)
    
end

function getMajorVersion(versionString)
    versionString = versionString or "v0"
    local dotIndex = string.find(versionString, '.', 1, true) or #versionString
    return string.sub(versionString, 2, dotIndex)
end

function checkRegInitialized()
    local savedVersion = regGetString('savegame.mod.verison')
    local currentVersion = "v4.5.0"
    -- Only reset mod if major version changed
    if getMajorVersion(savedVersion) ~= getMajorVersion(currentVersion) then
        modReset()
    end
    regSetString('savegame.mod.verison', currentVersion)
end

function regGetFloat(path)
    local p = 'savegame.mod.' .. path
    return GetFloat(p)
end
function regSetFloat(path, value)
    local p = 'savegame.mod.' .. path
    SetFloat(p, value)
end

function regGetInt(path)
    local p = 'savegame.mod.' .. path
    return GetInt(p)
end
function regSetInt(path, value)
    local p = 'savegame.mod.' .. path
    SetInt(p, value)
end

function regGetBool(path)
    local p = 'savegame.mod.' .. path
    return GetBool(p)
end
function regSetBool(path, value)
    local p = 'savegame.mod.' .. path
    SetBool(p, value)
end

function regGetString(path)
    local p = 'savegame.mod.' .. path
    return GetString(p)
end
function regSetString(path, value)
    local p = 'savegame.mod.' .. path
    SetString(p, value)
end

